#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_equipment.h"
#include "FileEncrypt.h"
std::auto_ptr<M_equipment> M_equipment::msSingleton(nullptr);

int M_equipment::GetCount()
{
	return (int)mMapData.size();
}

const M_equipmentData* M_equipment::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_equipmentData>& M_equipment::GetMapData()
{
	return mMapData;
}

void M_equipment::Reload()
{
	mMapData.clear();
	Load();
}

void M_equipment::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_equipmentData data;
		data.mID = element->IntAttribute("ID");
		data.mitemType = element->IntAttribute("itemType");
		data.mleve = element->IntAttribute("leve");
		data.mquality = element->Attribute("quality");
		{
			const char* cost1 = element->Attribute("cost1");
			std::vector<std::string> veccost1;
			boost::split(veccost1, cost1, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < veccost1.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(veccost1[i].c_str(), &temp))
				{
					data.mcost1.push_back(temp);
				}
			}
		}
		{
			const char* cost2 = element->Attribute("cost2");
			std::vector<std::string> veccost2;
			boost::split(veccost2, cost2, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < veccost2.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(veccost2[i].c_str(), &temp))
				{
					data.mcost2.push_back(temp);
				}
			}
		}
		{
			const char* reward = element->Attribute("reward");
			std::vector<std::string> vecreward;
			boost::split(vecreward, reward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecreward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecreward[i].c_str(), &temp))
				{
					data.mreward.push_back(temp);
				}
			}
		}
		data.matk = element->IntAttribute("atk");
		data.mhp = element->IntAttribute("hp");
		data.matkpct = element->IntAttribute("atkpct");
		data.mhppct = element->IntAttribute("hppct");
		data.mcrtpct = element->IntAttribute("crtpct");
		data.mmovepct = element->IntAttribute("movepct");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_equipment::Load()
{
	Load("../Config/M_equipment.xml");
}

M_equipment* M_equipment::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_equipment());
	}
	return msSingleton.get();
}
